module RCM
  class Package
    attr_accessor :name, :version, :current_state, :desired_state

    def ==(other)
      return false unless other.is_a?(RCM::Package)

      @installed = other.installed &&
      @name == other.name &&
      @version == other.version &&
      @current_state == other.current_state &&
      @desired_state == other.desired_state
    end

    def initialize(name, version, current_state, desired_state)
      @name = name
      @version = version
      @current_state = current_state
      @desired_state = desired_state
    end

    def to_s
      "Name = #{@name}\n" +
      "Version = #{@version}\n" +
      "Current State = #{@current_state}\n" +
      "Desired State = #{@desired_state}"
    end
  end
end
